/*根据id查找元素*/
function $id(id) {
	return document.getElementById(id);
}

/*根据class查找元素*/
function $class(className, parentDom) {
	if(parentDom) {
		return parentDom.getElementsByClassName(className);
	} else {
		return document.getElementsByClassName(className);
	}
}

/*创建元素,并设置类型和id*/
function create(_tag, _class, _id) {
	var newElement = document.createElement(_tag);
	if(_class != null)
		newElement.setAttribute("class", _class);
	if(_id != null)
		newElement.setAttribute("id", _id);
	return newElement;
}

function closeWindow() {
	var curWin = plus.webview.currentWebview();

	setTimeout(function() {
		//curWin.hide(); //避免出现关闭动画
		//mui.currentWebview.opener().show();
		curWin.close();
	}, 500);
}

function closeWindowHidden() {
	var curWin = plus.webview.currentWebview();

	setTimeout(function() {
		curWin.hide(); //避免出现关闭动画
		if(mui.currentWebview.opener() != null && mui.currentWebview.opener() != undefined) {
			mui.currentWebview.opener().show();
		}
		//curWin.close();
	}, 500);
}

/*打开界面的事件
 *params 参数json
 *接收参数: var self = plus.webview.currentWebview();self.key_src_array
 * */
function addOpenWindowEven(_id, _url, params) {
	$id(_id).addEventListener('tap', function() {
		openWindow(_url, params);
	});
}

/*打开界面*/
function openWindow(_url, params, isClose) {
	//跳转界面后是否关闭当前页面
	if(isClose) {
		var curWin = plus.webview.currentWebview();
		setTimeout(function() {
			if(curWin != undefined) {
				curWin.hide(); //避免出现关闭动画
				curWin.close();
			}
		}, 500);
	}
	var win = plus.webview.getWebviewById(_url);
	if(win) {
		//直接显示
		win.show();
		if(_url == "wallet.html") {
			//如果是我的钱包需刷新数据
			win.evalJS("getWalletData()");
		}
	} else {

		var aniShow = "slide-in-right";
		if(!mui.os.android) {
			aniShow = "pop-in";
		}
		//打开
		mui.openWindow({
			url: _url,
			id: _url,
			styles: {
				hardwareAccelerated: false
			},
			extras: params,
			waiting: {
				autoShow: false
			},
			show: {
				aniShow: aniShow,
				duration: 200,
			}
		});
	}
}

/*隐藏界面*/
function hideWindow(_url) {
	var win = plus.webview.getWebviewById(_url);
	if(win) win.hide();
}

/*获取用户当前位置的经纬度*/
function getCurPosition(success, error) {
	var _provider = "system";
	if(mui.os.android) {
		_provider = "baidu";
	}

	plus.geolocation.getCurrentPosition(function(position) {
		//console.log('定位成功-app' + JSON.stringify(position));
		var codns = position.coords; //获取地理坐标信息
		if(mui.os.android) {
			plus.storage.setItem("longitude", "" + codns.longitude);
			plus.storage.setItem("latitude", "" + codns.latitude);
			success(codns);
		} else {
//GPS坐标定位的时候 需要将坐标转换为百度坐标存储
			mui.ajax(Cxl.getzbzh(codns.longitude, codns.latitude), {
				data: null,
				dataType: 'json', //服务器返回json格式数据
				type: 'get', //HTTP请求类型
				timeout: 5000, //超时时间设置为5秒；
				success: function(data) {
					if(data != null && data.status == 0) {
						var info = data.result[0];
						plus.storage.setItem("longitude", "" + info.x);
						plus.storage.setItem("latitude", "" + info.y);
					} else {
						plus.storage.setItem("longitude", "0");
						plus.storage.setItem("latitude", "0");
					}
					console.log("进入");
					success({
						longitude: info.x,
						latitude: info.y
					});
					console.log("推出");
				},
				error: function(xhr, type, errorThrown) {
					plus.storage.setItem("longitude", "0");
						plus.storage.setItem("latitude", "0");
					success({
						longitude: "0",
						latitude: "0"
					});
				}
			});

		//	success(codns);
		}
	}, function(e) {
		//console.log(122);
		if(strIsEmpty(plus.storage.getItem("longitude")) && strIsEmpty(plus.storage.getItem("latitude"))) {

			plus.storage.setItem("longitude", "0");
			plus.storage.setItem("latitude", "0");
			success({
				longitude: "0",
				latitude: "0"
			});
		} else {
			success({
				longitude: plus.storage.getItem("longitude"),
				latitude: plus.storage.getItem("latitude")
			});
		}
	}, {
		geocode: false,
		provider: _provider
	});
}

/*经纬度获取省,市,区,街道*/
function getAddressComponent(latitude, longitude, success) {
	mui.ajax(Cxl.getPositionURL(latitude, longitude), {
		data: null,
		dataType: 'json', //服务器返回json格式数据
		type: 'get', //HTTP请求类型
		timeout: 5000, //超时时间设置为5秒；
		success: function(data) {
			if(data != null && data.status == 0) {
				var info = data.result.addressComponent;

				var lastcity = plus.storage.getItem("city");
				if(strIsEmpty(lastcity)) {
					plus.storage.setItem("city", info.city); //更新本地数据
					plus.storage.setItem("oldcity", "");
				} else {
					if(info.city == lastcity) {
						plus.storage.setItem("city", info.city); //更新本地数据
						plus.storage.setItem("oldcity", "");
					} else {
						//plus.storage.setItem("city", info.city); //更新本地数据
						plus.storage.setItem("oldcity", info.city);

					}
				}

			} else {
				plus.storage.setItem("city", "秦皇岛市"); //更新本地数据
				plus.storage.setItem("oldcity", "");
			}
			success();
		},
		error: function(xhr, type, errorThrown) {
			plus.storage.setItem("city", "秦皇岛市"); //更新本地数据
			plus.storage.setItem("oldcity", "");
			success();
		}
	});
}

/*json转参数*/
function jsonToParams(paramJson) {
	var params = "";
	for(var key in paramJson) {
		var _value = paramJson[key];
		if(_value) {
			if(_value != 0) params += "&" + key + "=" + _value;
		}
	}
	params = params.substr(1);
	return params;
}

/*暂无数据,显示空div*/
function showEmptyDiv(hintStr, todoStr, todoFun) {
	//检查是否已经创建
	var div_app_empty = $id("div_app_empty");
	if(div_app_empty) {
		div_app_empty.style.display = "block";
	} else {
		div_app_empty = create("div", null, "div_app_empty");
		div_app_empty.innerHTML = "<p class='mui-icon iconfont icon-empty_box'></p><p id='div_app_empty_p_hint'></p><p id='div_app_empty_p_todo'></p>";
		document.body.appendChild(div_app_empty);
	}
	//设置内容
	if(hintStr) $id("div_app_empty_p_hint").innerHTML = hintStr;
	var span_todo = $id("div_app_empty_p_todo");
	if(todoStr) span_todo.innerHTML = todoStr;
	if(todoFun) span_todo.addEventListener("tap", todoFun);
}

/*隐藏暂无数据的div*/
function hideEmptyDiv() {
	var div_app_empty = $id("div_app_empty");
	if(div_app_empty)
		div_app_empty.style.display = "none";
}

/*删除数组中的元素*/
Array.prototype.remove = function(dx) {
	if(isNaN(dx) || dx > this.length) {
		return false;
	}
	this.splice(dx, 1);
}

/*坐标由Wgs转bd*/
function bd09Encrypt(lon, lat) {
	//	
	//	var TO_GLNG = function(lng){return lng-0.0065;};
	//var TO_GLAT = function(lat){return lat-0.0060;};

	var lnglat = new Object();
	lnglat.longitude = lon;
	lnglat.latitude = lat;
	//lnglat.longitude = lon - 0.0065;
	//lnglat.latitude = lat - 0.0065;
	//
	//2、球面坐标转换
	//
	//复制代码
	//#include <math.h>    
	//const double x_pi = 3.14159265358979324 * 3000.0 / 180.0;  
	//void bd_decrypt(double bd_lat, double bd_lon, double &gg_lat, double &gg_lon)  
	//{  
	//  double x = bd_lon - 0.0065, y = bd_lat - 0.006;  
	//  double z = sqrt(x * x + y * y) - 0.00002 * sin(y * x_pi);  
	//  double theta = atan2(y, x) - 0.000003 * cos(x * x_pi);  
	//  gg_lon = z * cos(theta);  
	//  gg_lat = z * sin(theta);  
	//}  
	//复制代码

	//	var z = Math.sqrt(lon * lon + lat * lat) + 0.00002 * Math.sin(lat * Math.PI);
	//	var theta = Math.atan2(lat, lon) + 0.000003 * Math.cos(lon * Math.PI);
	//	var lnglat = new Object();
	//	lnglat.longitude = z * Math.cos(theta) + 0.0065;
	//	lnglat.latitude = z * Math.sin(theta) + 0.006;
	return lnglat;
}

/*是否为以前版本,小于targetVersion*/
function isVersionOld(targetVersion) {
	var appv = plus.runtime.version;
	var appvNmb = Number(appv.replace(".", ""));
	var tgtvNmb = Number(targetVersion.replace(".", ""));
	if(appvNmb < tgtvNmb) {
		return true;
	} else {
		return false;
	}
}

function strIsEmpty(obj) {
	if(obj == null || obj == "" || obj == undefined || obj == 'undefined' || obj == 'null') {
		return true;
	} else {
		return false;
	}
}

function getSessionid() {
	var sessionid = plus.storage.getItem("usersessionid");
	if(strIsEmpty(sessionid)) { //为空 跳转到输入手机号界面
		return false;
	} else {
		return true;
	}
}

//请求定位
function base_locationApp(callback) {
	var city = plus.storage.getItem('city');
	if(city == undefined || city == null || city == '' || city == 'null') {
		city = '秦皇岛市';
	}

	mui.post(Cxl.locationurl, {
		cityname: city
	}, function(data) {
		//console.log(data);
		//console.log(JSON.stringify(data));
		if(data.flag == 'SUCCESS') {
			//定位城市信息
			if(data.obj != undefined && data.obj != '') {
				plus.storage.setItem("locationcity", JSON.stringify(data.obj));
				//主城市编号信息
				plus.storage.setItem("parentcityids", data.obj.IDS);
			}

			//定位城市的子区域信息
			if(data.oneList != undefined && data.oneList != '') {
				plus.storage.setItem("childcity", JSON.stringify(data.oneList));
			}
			//定位城市的全部区域信息
			if(data.twoList != undefined && data.twoList != '') {
				plus.storage.setItem("parentcity", JSON.stringify(data.twoList));
			}
		} else {
			mui.toast('城市定位失败！请注意网络是否打开');
		}
		if(callback != undefined && callback != null && callback != '') {
			callback();
		}

	}, 'json');
}
var _add0 = function(num) {
	if(num < 10) {
		num = "0" + num;
	}
	return num;
}

Date.prototype.getDateStr = function(type) {
	var year = this.getFullYear();
	var month = this.getMonth() + 1;
	var date = this.getDate();
	var hours = this.getHours();
	var mins = this.getMinutes();
	var second = this.getSeconds();
	var add0 = function(num) {
		if(num < 10) {
			num = "0" + num;
		}
		return num;
	}
	if(type == 1) {
		return year + "年" + add0(month) + "月" + add0(date) + "日 " + add0(hours) + ":" + add0(mins) + ":" + add0(second);
	} else if(type == 2) {
		return year + "年" + add0(month) + "月" + add0(date) + "日";
	} else if(type == 3) {
		return year + "-" + add0(month) + "-" + add0(date);
	} else {
		return year + "-" + add0(month) + "-" + add0(date) + " " + add0(hours) + ":" + add0(mins) + ":" + add0(second);
	}
}

/*进度条:诚信 精品 正品*/
function showWaiting(hintText) {
	var content = "诚信 精品 正品";
	if(hintText) content = hintText;
	plus.nativeUI.showWaiting(content, {
		width: "50%",
		padding: "16px"
	});
}

function disableWait(t, obj, waitMessage) {
	var objTag = obj.tagName.toLowerCase();
	if(objTag !== "input" && objTag != "button") {
		return;
	}

	var v = objTag !== "input" ? obj.innerText : obj.value;
	var i = setInterval(function() {
		if(t > 0) {
			switch(objTag) {
				case "input":
					obj.value = (--t) + waitMessage;
					break;
				case "button":
					obj.innerText = (--t) + waitMessage;
					break;
				default:
					break;
			}
			obj.disabled = true;
		} else {
			window.clearInterval(i);

			obj.disabled = false;
		}
	}, 1000);
}